// code modified from mathworks.com
// HERE				ON PIC
// int			->	long int
// short int	->	int

#include<math.h>

#include "twiddles.h"					// twiddle factors real and imaginary
#include "rev_order.h"					// bit revered order array
#include "structure.h"					// defines structure
#include "data_sc4002e0_014_N2.h"		// data N2	(3)
//#include "data_sc4002e0_053_N4.h"		// data N4	(5)
//#include "data_sc4002e0_359_W.h"		// data W	(0)
//#include "data_sc4012e0_963_REM.h"	// data REM	(1)
//#include "data_sc4102e0_394_N1.h"		// data N1	(2)
//#include "data_sc4112e0_099_N3.h"		// data N3	(4)

// ********* FOR FFT *********
#define n 4096			// 4096 point FFT
#define t 12			// 12 stages

// ******* FOR SCALING *******
#define scale_factor	681
// sc4002	681
// sc4012	574
// sc4102	584
// sc4112	634

#define scale_yaxis		0x1BF6		// make y-axis into uV^2/Hz multiply by (1/Fs)/(1/#samples) = (1/100)/(1/3000) fix pt

int main(void)
{

	// ****************** FFT VARIABLES ******************

	unsigned int L;			// number of spectra in each stage
	unsigned int r;			// length in samples of the spectra in each stage
	unsigned int L2;		// number of butterfly calculations

	unsigned int loop;		// loop variable
	unsigned int q;			// stages number loop
	unsigned int k;			// spectra number loop
	unsigned int j;			// butterfly calculations number loop

	unsigned int kL;		// intermediate index calculation variable
	unsigned int n1;		// index calculation variable
	unsigned int n2;		// index calculation variable
	unsigned int n3;		// index calculation variable

	int tempr;				// butterfly multiplication component temp
	int tempi;				// butterfly multiplication component temp

	short int xr[4096];		// bit reversed order input array real component
	short int xi[4096];		// imaginary component

	unsigned int count = 0;		// ****DEBUG
	unsigned char variable;		// ****DEBUG

	short int wrN1, wiN1;		// ****DEBUG
	short int xrN2, xiN2;		// ****DEBUG
	short int xrN3, xiN3;		// ****DEBUG

	// ******************** SCALING **********************

	unsigned int output[4096];	// output array
	unsigned int output_temp;			

	// ****************** FOR FEATURES *******************

	unsigned int F1 = 0;			// index 17 to 63
	unsigned int F2 = 0;			// index 64 to 131
	unsigned int F3 = 0;			// index 132 to 352
	unsigned int F4 = 0;			// index 353 to 450
	unsigned int F5 = 0;			// index 451 to 638
	unsigned int F6 = 0;			// index 639 to 901
	unsigned int F7 = 0;			// index 902 to 1535
	unsigned int F8 = 0;			// total energy

	double F9 = 0;					// delta
	double F10 = 0;					// alpha
	double F11 = 0;					// kk & spindles
	double F12 = 0;					// alpha / theta
	double F13 = 0;					// delta / theta

	// ************** FOR LOG TRANSFORM ******************

	double log_features[13];

	// ************** FOR NEURAL NETWORK *****************

	unsigned char neuron_index, weight_index;
	unsigned char largest_index;
	double psleep_state[6];
	double largest_value;
	double a = 0;

	struct NEURONStruct hidden_neurons[10];
	struct NEURONStruct output_neurons[6];

// ________________________________________________________________________________________
// ****************************************************************************************
// H I D D E N  N E U R O N S
// ****************************************************************************************

// ********************************************
// HIDDEN NEURON 0
// --------------------------------------------
// weights
hidden_neurons[0].weights[0] =   5.7669753395170416;
hidden_neurons[0].weights[1] =   1.3815515203425199;
hidden_neurons[0].weights[2] =   0.6391863902198657;
hidden_neurons[0].weights[3] =   1.1922735765914825;
hidden_neurons[0].weights[4] =  -1.7616913125196021;
hidden_neurons[0].weights[5] =  -4.8089107417773533;
hidden_neurons[0].weights[6] =   1.2433039999533617;
hidden_neurons[0].weights[7] =  -0.6029292720489342;
hidden_neurons[0].weights[8] =  -0.3920267755817540;
hidden_neurons[0].weights[9] =   1.8882672846421678;
hidden_neurons[0].weights[10] =-12.0497148630910544;
hidden_neurons[0].weights[11] =  0.5160908746342023;
hidden_neurons[0].weights[12] = -1.8771844338989472;
// --------------------------------------------
// bias
hidden_neurons[0].bias = -17.45505592679422;

// ********************************************
// HIDDEN NEURON 1
// --------------------------------------------
// weights
hidden_neurons[1].weights[0] =  11.6967846851073887;
hidden_neurons[1].weights[1] =   0.3961329392163979;
hidden_neurons[1].weights[2] =  -1.3101956726310293;
hidden_neurons[1].weights[3] =  -2.3145540982585695;
hidden_neurons[1].weights[4] =   3.2750175824466470;
hidden_neurons[1].weights[5] =  -1.4811114330996615;
hidden_neurons[1].weights[6] =  -5.8564702426213602;
hidden_neurons[1].weights[7] =  -6.2519460581690440;
hidden_neurons[1].weights[8] =  -1.2497409239690758;
hidden_neurons[1].weights[9] =   4.1004516622245095;
hidden_neurons[1].weights[10] =  2.0299069103420475;
hidden_neurons[1].weights[11] = -0.8561316523575272;
hidden_neurons[1].weights[12] = -0.3415869071853527;
// --------------------------------------------
// bias
hidden_neurons[1].bias = -6.34131199450068;

// ********************************************
// HIDDEN NEURON 2
// --------------------------------------------
// weights
hidden_neurons[2].weights[0] = -0.186870415888053837;
hidden_neurons[2].weights[1] =  0.016389795249118381;
hidden_neurons[2].weights[2] = -0.153580253325946686;
hidden_neurons[2].weights[3] = -0.004226620708531685;
hidden_neurons[2].weights[4] =  0.084874260002671967;
hidden_neurons[2].weights[5] =  0.080852502415327127;
hidden_neurons[2].weights[6] = -0.092671072056368625;
hidden_neurons[2].weights[7] = -0.253817620545253642;
hidden_neurons[2].weights[8] = -0.152541899757467347;
hidden_neurons[2].weights[9] =  0.068230720698712499;
hidden_neurons[2].weights[10] = 0.300418159393995077;
hidden_neurons[2].weights[11] = 0.018210695069983237;
hidden_neurons[2].weights[12] = 0.166598926970781436;
// --------------------------------------------
// bias
hidden_neurons[2].bias = 0.3470682041302182;

// ********************************************
// HIDDEN NEURON 3
// --------------------------------------------
// weights
hidden_neurons[3].weights[0] =  0.32689280288295075;
hidden_neurons[3].weights[1] =  0.25823440136015163;
hidden_neurons[3].weights[2] =  0.23239110240788705;
hidden_neurons[3].weights[3] =  0.06390832276524439;
hidden_neurons[3].weights[4] =  0.10179775890275609;
hidden_neurons[3].weights[5] =  0.10296612971668459;
hidden_neurons[3].weights[6] =  0.06611357409080391;
hidden_neurons[3].weights[7] =  0.35210444748413322;
hidden_neurons[3].weights[8] = -0.12195861253296740;
hidden_neurons[3].weights[9] = -0.20123057697535607;
hidden_neurons[3].weights[10] =-0.01342061298896045;
hidden_neurons[3].weights[11] =-0.03882434351467019;
hidden_neurons[3].weights[12] = 0.01974291245509730;
// --------------------------------------------
// bias
hidden_neurons[3].bias = -0.0494615537355705;

// ********************************************
// HIDDEN NEURON 4
// --------------------------------------------
// weights
hidden_neurons[4].weights[0] =  2.4553010660915500;
hidden_neurons[4].weights[1] =  4.0413659989124433;
hidden_neurons[4].weights[2] = -2.2754909535319445;
hidden_neurons[4].weights[3] = -2.3660452311695481;
hidden_neurons[4].weights[4] =  5.3723839633670432;
hidden_neurons[4].weights[5] = -1.1566383234564128;
hidden_neurons[4].weights[6] = -0.3381030668152914;
hidden_neurons[4].weights[7] = -3.2710620354278572;
hidden_neurons[4].weights[8] =  1.4255956987841927;
hidden_neurons[4].weights[9] =  0.7860849522145303;
hidden_neurons[4].weights[10] =-5.6097769103181250;
hidden_neurons[4].weights[11] =-0.1130883182265120;
hidden_neurons[4].weights[12] = 3.7123733282777516;
// --------------------------------------------
// bias
hidden_neurons[4].bias = -8.684628480454037; 

// ********************************************
// HIDDEN NEURON 5
// --------------------------------------------
// weights   
hidden_neurons[5].weights[0] = -0.7551948157335647;
hidden_neurons[5].weights[1] = -8.0235389687373857;
hidden_neurons[5].weights[2] =  2.3666506184286469;
hidden_neurons[5].weights[3] =  4.5962898419369882;
hidden_neurons[5].weights[4] = -9.9091637379504558;
hidden_neurons[5].weights[5] =  4.2000931864139517;
hidden_neurons[5].weights[6] =  1.1808956914300612;
hidden_neurons[5].weights[7] =  4.7082844178800567;
hidden_neurons[5].weights[8] = -3.9275487713271424;
hidden_neurons[5].weights[9] = -0.0290211261815712;
hidden_neurons[5].weights[10] =-0.1055216919087220;
hidden_neurons[5].weights[11] = 2.2530704620746280;
hidden_neurons[5].weights[12] =-4.6803427549653973;
// --------------------------------------------
// bias
hidden_neurons[5].bias = 0.448145597194451; 

// ********************************************
// HIDDEN NEURON 6
// --------------------------------------------
// weights
hidden_neurons[6].weights[0] =  -0.14244027033532669;
hidden_neurons[6].weights[1] =  -0.31789303389266399;
hidden_neurons[6].weights[2] =  -0.26904455964703666;
hidden_neurons[6].weights[3] =  -0.21782579744120001;
hidden_neurons[6].weights[4] =  -0.15497462364981909;
hidden_neurons[6].weights[5] =  -0.15246937849237338;
hidden_neurons[6].weights[6] =  -0.05645400405147904;
hidden_neurons[6].weights[7] =  -0.30808255136645629;
hidden_neurons[6].weights[8] =  -0.01265042015454116;
hidden_neurons[6].weights[9] =   0.10921928933921968;
hidden_neurons[6].weights[10] = -0.12992364888608451;
hidden_neurons[6].weights[11] =  0.14599153205949819;
hidden_neurons[6].weights[12] = -0.07086469937608011;
// --------------------------------------------
// bias
hidden_neurons[6].bias = -0.01159635195894679;

// ********************************************
// HIDDEN NEURON 7
// --------------------------------------------
// weights
hidden_neurons[7].weights[0] =  0.7559127358305633;
hidden_neurons[7].weights[1] = -2.9955314192939042;
hidden_neurons[7].weights[2] = -0.7984778679710617;
hidden_neurons[7].weights[3] =  2.4347348948962249;
hidden_neurons[7].weights[4] =-10.4958874006473923;
hidden_neurons[7].weights[5] = -0.5838799084053261;
hidden_neurons[7].weights[6] =  6.0855432850080655;
hidden_neurons[7].weights[7] =  4.8240610390706742;
hidden_neurons[7].weights[8] =  2.2768844461635687;
hidden_neurons[7].weights[9] = -2.2120860251450236;
hidden_neurons[7].weights[10] = 0.1116406214155215;
hidden_neurons[7].weights[11] = 3.3204839644315953;
hidden_neurons[7].weights[12] =-3.5629403887007220;
// --------------------------------------------
// bias
hidden_neurons[7].bias = 1.667365702627106; 

// ********************************************
// HIDDEN NEURON 8
// --------------------------------------------
// weights
hidden_neurons[8].weights[0] =  0.32398553225905768;
hidden_neurons[8].weights[1] =  0.19956225110361117;
hidden_neurons[8].weights[2] =  0.13891581498560951;
hidden_neurons[8].weights[3] =  0.17229232000169473;
hidden_neurons[8].weights[4] =  0.21967414512844721;
hidden_neurons[8].weights[5] =  0.19563799194920206;
hidden_neurons[8].weights[6] =  0.14093935605033156;
hidden_neurons[8].weights[7] =  0.22256116454434482;
hidden_neurons[8].weights[8] = -0.15530563196236463;
hidden_neurons[8].weights[9] = -0.24626202531489502;
hidden_neurons[8].weights[10] =-0.09139506387365627;
hidden_neurons[8].weights[11] =-0.09087115936961479;
hidden_neurons[8].weights[12] = 0.01590694621826582;
// --------------------------------------------
// bias
hidden_neurons[8].bias = 0.01693172447926194;

// ********************************************
// HIDDEN NEURON 9
// --------------------------------------------
// weights
hidden_neurons[9].weights[0] =  0.1929238435585868;
hidden_neurons[9].weights[1] = -5.1800842608521913;
hidden_neurons[9].weights[2] = -1.3036601301416575;
hidden_neurons[9].weights[3] = -2.4043871435952564;
hidden_neurons[9].weights[4] = 10.7613879516985111;
hidden_neurons[9].weights[5] = -8.2971330266497301;
hidden_neurons[9].weights[6] = -3.4770029928965474;
hidden_neurons[9].weights[7] =  1.8096684964731453;
hidden_neurons[9].weights[8] = -0.1382951622670105;
hidden_neurons[9].weights[9] = -3.9740983988742351;
hidden_neurons[9].weights[10] = 3.5649478730731752;
hidden_neurons[9].weights[11] =-0.9991372213057425;
hidden_neurons[9].weights[12] = 0.4611523715951049;
// --------------------------------------------
// bias
hidden_neurons[9].bias = 3.642068608223434;

// ****************************************************************************************
// O U T P U T  N E U R O N S
// ****************************************************************************************

// ********************************************
// OUTPUT NEURON 0
// --------------------------------------------
// weights
output_neurons[0].weights[0] =  0.0074431400312085288;
output_neurons[0].weights[1] = -0.0183035906951559274;
output_neurons[0].weights[2] = -0.3477433537243346806;
output_neurons[0].weights[3] = -0.1380874003318022791;
output_neurons[0].weights[4] =  0.1522636749254012989;
output_neurons[0].weights[5] =  0.2233509569008584883;
output_neurons[0].weights[6] = -0.0374931693951777861;
output_neurons[0].weights[7] =  0.1941623947078104095;
output_neurons[0].weights[8] =  0.0330566253071347960;
output_neurons[0].weights[9] =  0.0008388492583943174;
// --------------------------------------------
// bias
output_neurons[0].bias = -0.1164561828669849;

// ********************************************
// OUTPUT NEURON 1
// --------------------------------------------
// weights
output_neurons[1].weights[0] =  0.167767167620562069;
output_neurons[1].weights[1] =  0.011440133730674037;
output_neurons[1].weights[2] =  0.010205073301644257;
output_neurons[1].weights[3] = -0.042143502622747221;
output_neurons[1].weights[4] = -0.187607413753266644;
output_neurons[1].weights[5] = -0.200339280201605102;
output_neurons[1].weights[6] =  0.009324682304315199;
output_neurons[1].weights[7] =  0.037424969696709824;
output_neurons[1].weights[8] = -0.042582920428612163;
output_neurons[1].weights[9] =  0.009330929844474934;
// --------------------------------------------
// bias
output_neurons[1].bias = -0.04458805690041043;

// ********************************************
// OUTPUT NEURON 2
// --------------------------------------------
// weights
output_neurons[2].weights[0] = -0.19848146292557747;
output_neurons[2].weights[1] = -0.04742466351054590;
output_neurons[2].weights[2] =  0.90046441313321901;
output_neurons[2].weights[3] =  0.29221649692277551;
output_neurons[2].weights[4] =  0.01217988446959622;
output_neurons[2].weights[5] = -0.02055777931036423;
output_neurons[2].weights[6] = -0.32533208034110295;
output_neurons[2].weights[7] = -0.04147315026489684;
output_neurons[2].weights[8] =  0.34749245368823883;
output_neurons[2].weights[9] = -0.03076869971249916;
// --------------------------------------------
// bias
output_neurons[2].bias = 0.28467682692906;

// ********************************************
// OUTPUT NEURON 3
// --------------------------------------------
// weights
output_neurons[3].weights[0] =  0.016398544879947231;
output_neurons[3].weights[1] = -0.202697930164040918;
output_neurons[3].weights[2] = -0.211069423463204897;
output_neurons[3].weights[3] = -0.001521921140742176;
output_neurons[3].weights[4] = -0.004565282369968037;
output_neurons[3].weights[5] =  0.001784066354940901;
output_neurons[3].weights[6] =  0.145700594045913040;
output_neurons[3].weights[7] = -0.170253953504386435;
output_neurons[3].weights[8] = -0.028285060226943218;
output_neurons[3].weights[9] =  0.028467004734494337;
// --------------------------------------------
// bias
output_neurons[3].bias = -0.07921572017969372;

// ********************************************
// OUTPUT NEURON 4
// --------------------------------------------
// weights
output_neurons[4].weights[0] =  0.018029649159877155;
output_neurons[4].weights[1] =  0.102269225388207111;
output_neurons[4].weights[2] =  0.162606012651390575;
output_neurons[4].weights[3] =  0.155552020140142411;
output_neurons[4].weights[4] =  0.009927172674456052;
output_neurons[4].weights[5] =  0.002894640890885458;
output_neurons[4].weights[6] = -0.051157774274448793;
output_neurons[4].weights[7] = -0.014416033392569336;
output_neurons[4].weights[8] =  0.113252763010326885;
output_neurons[4].weights[9] =  0.157965469095747602;
// --------------------------------------------
// bias
output_neurons[4].bias = 0.0844779641023337;

// ********************************************
// OUTPUT NEURON 5
// --------------------------------------------
// weights
output_neurons[5].weights[0] = -0.011477035093386104;
output_neurons[5].weights[1] =  0.154686794342575457;
output_neurons[5].weights[2] = -0.540429431084405665;
output_neurons[5].weights[3] = -0.181155796351241349;
output_neurons[5].weights[4] =  0.017660629772417925;
output_neurons[5].weights[5] = -0.007206904389039881;
output_neurons[5].weights[6] =  0.155760504137973849;
output_neurons[5].weights[7] = -0.005458649433443686;
output_neurons[5].weights[8] = -0.120728259927613518;
output_neurons[5].weights[9] = -0.165731133988698875;
// --------------------------------------------
// bias
output_neurons[5].bias = -0.01358876769771539;

	// **************************************************************************************************************
	// ----------------------------------------- C O D E  S T A R T S  H E R E---------------------------------------
	// **************************************************************************************************************

	// populate imaginary component of input with zeros
	for(loop = 0; loop < n; loop++)
	{
		xi[loop] = 0;
	}
	
	// bit reverse order array
	for(loop = 0; loop < n; loop++)
	{
		xr[loop] = input_r[bit_rev_order[loop]];
	}

	// begin FFT calculation
	for(q = 1; q <= t; q++)
	{
		L = 1; L <<= q;			// 2^q stages
		r = 1; r <<= (t - q);	// samples in each stage
		L2 = L >> 1;			// butterfly calculations

		kL = 0;

		for(k = 0; k < r; k++)
		{
			for(j = 0; j < L2; j++)
			{
				n3 = kL + j;		// determine array indexes
				n2 = n3 + L2;
				n1 = L2 - 1 + j;


				// **** DEBUG
				wrN1 = wr[n1];
				wiN1 = wi[n1];
				xrN2 = xr[n2];
				xiN2 = xi[n2];
				xrN3 = xr[n3];
				xiN3 = xi[n3];

				// **** DEBUG
				if(count == 0x801)
				{
					variable = 0;
				}

				// butterfly:
				// A = a + twiddles*b
				// B = b - twiddles*b
				// so first twiddles*b (both complex)
				// (inputR + inputI)(twiddlesR + twiddlesI)
				tempr = ((int)wr[n1] * (int)xr[n2] >> 15) - ((int)wi[n1] * (int)xi[n2] >> 15);
				tempi = ((int)wr[n1] * (int)xi[n2] >> 15) + ((int)wi[n1] * (int)xr[n2] >> 15);

				// **** DEBUG
				wrN1 = wr[n1];
				wiN1 = wi[n1];
				xrN2 = xr[n2];
				xiN2 = xi[n2];
				xrN3 = xr[n3];
				xiN3 = xi[n3];



				// then the addition and subrtaction part
				xr[n2] = ((int)xr[n3] - tempr) >> 1;
				xi[n2] = ((int)xi[n3] - tempi) >> 1;
				xr[n3] = ((int)xr[n3] + tempr) >> 1;
				xi[n3] = ((int)xi[n3] + tempi) >> 1;

				// **** DEBUG
				//if(count == 0xFFF)
				//{
				//	variable = 0;
				//}
				

				// **** DEBUG
				xrN2 = xr[n2];
				xiN2 = xi[n2];
				xrN3 = xr[n3];
				xiN3 = xi[n3];

				// **** DEBUG
				//if(xiN2 == 0x003e || xiN3 == 0x003e)
				//{
				//	variable = 0;
				//}


				// ****DEBUG
				count += 1;

			}

			kL += L;
		}
	}

	// ***************************************************
	// find absolute value and do scaling
	for(loop = 0; loop < n; loop++)
	{
		output_temp = pow(xr[loop],2) + pow(xi[loop],2);
		output[loop] = (output_temp * scale_yaxis) >> 16;		// y-axis in uV/Hz
		output[loop] = (output[loop] * scale_factor) >> 10;		// subtract base divide by gain scaling
		//output[loop] *=2;										// shift by 14 instead of 15 does -> single sided so multiply by 2
																// shift by 10 do the addition and then right shift values off by 4
	}

	// ***************************************************
	// calculate features
	for(loop = 17; loop < 64; loop++)
	{
		F1 += output[loop];
	}
	F1 = F1 >> 4;
	
	for(loop = 64; loop < 132; loop++)
	{
		F2 += output[loop];
	}
	F2 = F2 >> 4;

	for(loop = 132; loop < 353; loop++)
	{
		F3 += output[loop];
	}
	F3 = F3 >> 4;

	for(loop = 353; loop < 451; loop++)
	{
		F4 += output[loop];
	}
	F4 = F4 >> 4;

	for(loop = 451; loop < 639; loop++)
	{
		F5 += output[loop];
	}
	F5 = F5 >> 4;

	for(loop = 639; loop < 902; loop++)
	{
		F6 += output[loop];
	}
	F6 = F6 >> 4;

	for(loop = 902; loop < 1536; loop++)
	{
		F7 += output[loop];
	}
	F7 = F7 >> 4;

	F8 = F1 + F2 + F3 + F4 + F5 + F6 + F7;
	F9 = ((double)F1 + (double)F2) / (double)F8;
	F10 = (double)F4 / (double)F8;
	F11 = ((double)F1 + (double)F5) / (double)F8;
	F12 = (double)F4 / (double)F3;
	F13 = ((double)F1 + (double)F2) / (double)F3;

	// ***************************************************
	// log transform features

	log_features[0] = log((double)F1);
	log_features[1] = log((double)F2);
	log_features[2] = log((double)F3);
	log_features[3] = log((double)F4);
	log_features[4] = log((double)F5);
	log_features[5] = log((double)F6);
	log_features[6] = log((double)F7);
	log_features[7] = log((double)F8);
	log_features[8] = log(1-(double)F9);
	log_features[9] = log(F10);
	log_features[10] = F11;
	log_features[11] = log(F12);
	log_features[12] = log(F13);

	// ***************************************************
	// run neural network

	// increment through hidden neurons
	for(neuron_index=0; neuron_index < 10; neuron_index++)
	{
		// increment through weights
		for(weight_index=0; weight_index < 13; weight_index++)
		{
			a += hidden_neurons[neuron_index].weights[weight_index] * log_features[weight_index];
		}
	
		a += hidden_neurons[neuron_index].bias;

		hidden_neurons[neuron_index].v0 = a_tansig * tanh(a * b_tansig);
		
		a = 0;
	}

	// increment through output neurons
	for(neuron_index=0; neuron_index < 6; neuron_index++)
	{
		// increment through weights
		for(weight_index=0; weight_index < 10; weight_index++)
		{
			a += output_neurons[neuron_index].weights[weight_index] * hidden_neurons[weight_index].v0;
		}
	
		a += output_neurons[neuron_index].bias;

		output_neurons[neuron_index].v0 = a;
		
		a = 0;
	}

	for(neuron_index=0; neuron_index < 6; neuron_index++)
	{
		psleep_state[neuron_index] = output_neurons[neuron_index].v0;
	}

	largest_index = 0;
	largest_value = psleep_state[0];

	for(neuron_index=1; neuron_index < 6; neuron_index++)
	{
		if(psleep_state[neuron_index] > largest_value)
		{
			largest_index = neuron_index;
			largest_value = psleep_state[neuron_index]; 			
		}
	}

	return(0);
}