// --------------------------------------------------------------
// **************************************************************
// PLEASE NOTE THIS PROGRAM SENDS THE EEG DATA IN 32 BYTE PACKETS
// **************************************************************
// --------------------------------------------------------------
#include <stdio.h>
#include <stdlib.h>
#include <windows.h>
#include <time.h>
#include <unistd.h>

#include "twiddles.h"
#include "rev_order.h"

#include "data_sc4002e0_359_W.h"
#include "data_sc4012e0_963_REM.h"
#include "data_sc4102e0_394_N1.h"
#include "data_sc4002e0_014_N2.h"
#include "data_sc4112e0_099_N3.h"

#define SC4002	1
#define SC4012	2
#define SC4102	3
#define SC4112	4

// *************** FOR SERIAL FUNCTIONS ***************
unsigned char szBuff[4];
int n = 300;
DWORD dwBytesRead = 0;


// ***************** FOR TRANSMISSION *****************
unsigned char HIbyte;
unsigned char LObyte;

unsigned int loop = 0;
unsigned int loop2 = 0;
unsigned int count = 0;

// ******************** FOR MENU **********************
unsigned int selection = 0;
unsigned char gain_factor = 0;

//short int input_r[4096];
short int *ptr;

// ****************************************************

// *********************************************************************************
// M A I N
// *********************************************************************************
int main(int argc, char *argv[])
{


    // ****************************************************
    // OPEN SERIAL PORT
    HANDLE hSerial;
    hSerial = CreateFile("COM1",
    GENERIC_READ | GENERIC_WRITE,
    0,
    0,
    OPEN_EXISTING,
    FILE_ATTRIBUTE_NORMAL,
    0);
    
    if(hSerial==INVALID_HANDLE_VALUE)
    {
        if(GetLastError()==ERROR_FILE_NOT_FOUND)
        {
            printf("Serial port does not exist. Inform user.");
        }
        printf("Some other init error occurred.");
    }
    
    DCB dcbSerialParams = {0};
    dcbSerialParams.DCBlength=sizeof(dcbSerialParams);
    if (!GetCommState(hSerial, &dcbSerialParams)) 
    {
        printf("params 1 error getting state");
    }
    dcbSerialParams.BaudRate=CBR_115200;
    dcbSerialParams.ByteSize=8;
    dcbSerialParams.StopBits=ONESTOPBIT;
    dcbSerialParams.Parity=NOPARITY;
    if(!SetCommState(hSerial, &dcbSerialParams))
    {
        printf("params 2 error setting serial port state");
    }
    
    COMMTIMEOUTS timeouts={0};
    timeouts.ReadIntervalTimeout=50;
    timeouts.ReadTotalTimeoutConstant=500;
    timeouts.ReadTotalTimeoutMultiplier=10;
    timeouts.WriteTotalTimeoutConstant = 100;
	timeouts.WriteTotalTimeoutMultiplier = 100;

    
    if(!SetCommTimeouts(hSerial, &timeouts))
    {
        printf("timeout error occurred. Inform user");
    }
    
    // ****************************************************
    // MENU
while(1)
{
    printf("\n\n                                                                    ``.      \n");
    printf("               y+                                             ``h:yhMMMmho:  \n");
    printf("         .:///:MM/-///-`     `.:////   `-////.  `.://-`    -/omsmMMMMMMMMMMy \n");
    printf("       .hMmhhs-MMNNdhdNNs`  +mNdhhy: -yNmhhyo` +mNdhhNNy. -NNNNdNMMMMMMMMMMM.\n");
    printf("       hMh`    MMh.   .yMd sMm--:::-.NMo.-:::`sMm-   `sMN` `-ymhmMMMMMMMMMMy`\n");
    printf("       dMo     MM/     -MM`dMs`hddh/:MM./dddy.mMo     -MM-   .. `oNNmNmmNN/. \n");
    printf("   ..-oMN:     MM:     -MM`:mNs-...  yMd/-..` mMs...-+mNy         yd.-``ym   \n");
    printf("  oddmdy-      dy`     `sm` .+hddddo  :sddddh.mMNddddds:          od    sd   \n");
    printf("  ````         `         `     `````     `````mN/````              `     `   \n");
    printf("                                              -.-.                           \n");
    printf("       ````     ```     `         `      ``     dN:           ````      ```` \n");
    printf("    :sdmmmh. -odmmmho. `ms`     `ym  .ohmmmds-  dMo  ```  `+hmmmds  .ohmmmd+ \n");
    printf("   yMd/...` oNN+-.-oNN/.MM-     /MM /NNo-.-+mNo dMo`dmd: .mMy:...` /NNo-...  \n");
    printf("  :MM`     `MM/     +MN`MM-     /MM NMo     :MM`dMo `.`  yMh ydddy NM+       \n");
    printf("  .NM+      dMy`   .hMh dMy`   .hMh NM/     -MM.oMm-     +MN-.---` MM/       \n");
    printf("   .yNNhhyo``sNNdhdNNo` `sNNdhdNNo` NM-     .NM. +mMdhhy: /dMmhhy/ MM-       \n");
    printf("     `-////.  `-///-      `-///-    /.       `/`   .:////   .://// /.        \n\n\n");

    printf("\tWelcome to the Sheep Counter demo application.\n");
    printf("\tThis application emulates an EEG.  Sleep EEG\n");
    printf("\tdata is serially transmitted to to the signal\n");
    printf("\tprocessing unit to be automaticlly scored.\n\n");
    printf("\tSelect a file to transmit:\n\n");
    printf("\t1)   Awake\n");
    printf("\t2)   REM\n");
    printf("\t3)   N1\n");
    printf("\t4)   N2\n");
    printf("\t5)   N3\n\n");
    printf("\tSelection: ");
    
    scanf("%d", &selection);
    
    system("cls");
    
    switch(selection)
    {
         case 1:
         {
                ptr = &sc4002e0_359[0];             
              gain_factor = SC4002;
              break;
         }
         case 2:
         {
                ptr = &sc4012e0_963[0];     
              gain_factor = SC4012;
              break;
         }
         case 3:
         {
              
                ptr = &sc4102e0_394[0];                          
              gain_factor = SC4102;              
              break;
         }
         case 4:
         {
                ptr = &sc4002e0_014[0];
              gain_factor = SC4002;              
              break;
         }
         case 5:
         {
                ptr = &sc4112e0_099[0];           
              gain_factor = SC4112;              
              break;
         }
        default:
        {
                ptr = &sc4002e0_359[0];             
              gain_factor = SC4002;
            break;    
        }

    }
       
    // ****************************************************
    // TX STUFF STARTS HERE

    //-----------------------------------------------------
    // SEND GAIN FACTOR
    
    ////////////////////////////////////////////////////////////////!!!!!!!!!!!!!!!!
    count = 0; ///////////THIS WAS THE PROBLEM!!! IT WAS NOT HERE BEFORE!!!!!!!!!!!!
    ///////////////////////////////////////////////////////////////!!!!!!!!!!!!!!!!!
    
    n = 4;
        
    szBuff[0] = 0xFF;
    szBuff[1] = 0xA5;
    szBuff[2] = 0x5A;
    szBuff[3] = gain_factor;                         
   
    //printf("BEGIN %d %d %d ",szBuff[0],szBuff[1],szBuff[2]);
        
    if(!WriteFile(hSerial, szBuff, n, &dwBytesRead, NULL)) //writes serial data
    {
        printf("error occurred. Report to user.");
    }    

    //-----------------------------------------------------
    // SEND DATA   
        
    for(loop = 0; loop < 256; loop++)
    {
        n = 3;
        
        szBuff[0] = 0x7E;
        szBuff[1] = 0x40;
        szBuff[2] = 0x40;                         
   
        //printf("BEGIN %d %d %d ",szBuff[0],szBuff[1],szBuff[2]);
        
        if(!WriteFile(hSerial, szBuff, n, &dwBytesRead, NULL)) //writes serial data
        {
            printf("error occurred. Report to user.");
        }
        
        for(loop2 = 0; loop2 < 16; loop2++)
        {    
             n = 2;
                                    
             HIbyte = (*(ptr + count) >> 8) & 0xFF;
             LObyte = *(ptr + count) & 0xFF;
        
                //printf(" Begin - %d,%d",HIbyte,LObyte); //DEBUG TO MAKE SURE POINTER WORKS FOR VALUES
                //system("PAUSE");
        
             szBuff[0] = HIbyte;
             szBuff[1] = LObyte;
                                     
             count += 1;
             
             if(!WriteFile(hSerial, szBuff, n, &dwBytesRead, NULL)) //writes serial data
             {
                  printf("error occurred. Report to user.");
             }      
        }
      
     }        

    printf("Transmission Complete\n");

    //CloseHandle(hSerial);

    system("PAUSE");
    system("cls");	
}
    
    
    return 0;
}
