#include<p33fxxxx.h>
#include<uart.h>

void configureUART(void)
{
	// -----------------------------------------
	// definitions UART1
	#define FCY1 40000000
	#define BAUDRATE1 115200
	#define BRGVAL1 ((FCY1/BAUDRATE1)/16) - 1

	// -----------------------------------------
	// definitions UART2
	#define FCY2 40000000
	#define BAUDRATE2 115200
	#define BRGVAL2 ((FCY2/BAUDRATE2)/16) - 1

	// *****************************************************************
	// configure interrupt
	// *****************************************************************
	INTCON1bits.NSTDIS = 0;						// disable nested interrupts
	IPC2bits.U1RXIP0 = 1;						// UART1 highest priority interrupt
	IPC2bits.U1RXIP1 = 1;
	IPC2bits.U1RXIP2 = 1;
	IFS0bits.U1RXIF = 0;						// clear RX interrupt status flag
	IEC0bits.U1RXIE = 1;						// enable RX interupt
	
	// *****************************************************************
	// configure UART 1 
	// *****************************************************************
	RPINR18bits.U1RXR = 2;						// set RB2 to input for UART RX
	//RPOR1bits.RP3R = 0b00011;					// ****set RB3 to output for UART TX

	U1MODEbits.UARTEN = 0;						// UART disabled
	U1MODEbits.USIDL = 0;						// continue in idle mode
	U1MODEbits.IREN = 0;						// disable IrDA
	U1MODEbits.RTSMD = 0;						// UxRTS in simplex mode
	U1MODEbits.UEN = 0;							// TX and RX pins enabled and used
	U1MODEbits.WAKE = 0;						// no wake up enabled
	U1MODEbits.LPBACK = 0;						// no Loop Back
	U1MODEbits.ABAUD = 0;						// disable auto baud
	U1MODEbits.URXINV = 0;						// IdleState = 1  (for dsPIC)
	U1MODEbits.BRGH = 0;						// 16 clocks per bit period
	U1MODEbits.PDSEL = 0;						// 8-bit data no parity
	U1MODEbits.STSEL = 0;						// one Stop Bit

	U1BRG = BRGVAL1;							// set baud rate

	U1STAbits.UTXISEL1 = 0;						// int when char is transferred
	U1STAbits.UTXINV = 0;						// N/A, IRDA config
	U1STAbits.UTXISEL0 = 0;						// int when char is transferred
	U1STAbits.UTXBRK = 0;						// disabled
	U1STAbits.UTXEN = 0;						// TX disabled
	U1STAbits.URXISEL = 0;						// int on character recieved
	U1STAbits.ADDEN = 0;						// address detect disabled

	U1MODEbits.UARTEN = 1;						// UART enabled
	U1STAbits.UTXEN = 1;						// TX enabled

	// *****************************************************************
	// configure UART 2 
	// *****************************************************************
	RPOR1bits.RP3R = 0b00101;					// set RB3 to output for UART2 TX

	U2MODEbits.UARTEN = 0;						// UART disabled
	U2MODEbits.USIDL = 0;						// continue in idle mode
	U2MODEbits.IREN = 0;						// disable IrDA
	U2MODEbits.RTSMD = 0;						// UxRTS in simplex mode
	U2MODEbits.UEN = 0;							// TX and RX pins enabled and used
	U2MODEbits.WAKE = 0;						// no wake up enabled
	U2MODEbits.LPBACK = 0;						// no Loop Back
	U2MODEbits.ABAUD = 0;						// disable auto baud
	U2MODEbits.URXINV = 0;						// IdleState = 1  (for dsPIC)
	U2MODEbits.BRGH = 0;						// 16 clocks per bit period
	U2MODEbits.PDSEL = 0;						// 8-bit data no parity
	U2MODEbits.STSEL = 0;						// one Stop Bit

	U2BRG = BRGVAL2;							// set baud rate

	U2STAbits.UTXISEL1 = 0;
	U2STAbits.UTXINV = 0;						// N/A, IRDA config
	U2STAbits.UTXISEL0 = 0;						// int when char is transferred
	U2STAbits.UTXBRK = 0;						// disabled
	U2STAbits.UTXEN = 0;						// TX disabled
	U2STAbits.URXISEL = 0;						// int on character recieved
	U2STAbits.ADDEN = 0;						// address detect disabled

	U2MODEbits.UARTEN = 1;						// UART enabled
	U2STAbits.UTXEN = 1;						// TX enabled

}
