#include<p33fj128gp802.h>
#include<uart.h>
#include<dsp.h>
#include "SPIFlash.h"
#include "spi.h"

void parse_packet(void)
{
	// ----------------------------------------------
	// external variables
	extern unsigned char state;
	extern unsigned char count;
	extern unsigned char data;
	extern int flag;

	extern int byte_count;
	extern unsigned char data_set;

	unsigned char packet_switch;

	// *********************************************************************************
	// P A R S E  R O U T I N E
	// *********************************************************************************	
	if(U1STAbits.URXDA)
	{
		switch(state)
		{
			case 0:				// sync byte 1
			{
				packet_switch = U1RXREG;

				switch(packet_switch)
				{
					case 0x7E:
					{
						state = 1;
						packet_switch = 0;
						break;
					}
					case 0xFF:
					{
						packet_switch = 0;
						state = 4;
						break;
					}
					default:
					{
						packet_switch = 0;
						state = 0;
						break;
					}					
				}
				break;
			}
			case 1:				// sync byte 2
			{
				if(U1RXREG == 0x40)
				{
					state = 2;
				}
				else
				{
					state = 0;
				}
				break;	
			}
			case 2:				// sync byte 3
			{
				if(U1RXREG == 0x40)
				{
					state = 3;
				}
				else
				{
					state = 0;
				}
				break;
			}
			case 3:				// data
			{
				data = U1RXREG;
				SPIFlashWrite(data);
				count += 1;

				if(count == 32)
				{
					count = 0;
					state = 0;
					flag += 1;
				}
					
				byte_count += 1;	// for capstone demo;
				break;
			}
			
			// ***************************************************
			// data_set packet
			case 4:
			{
				if(U1RXREG == 0xA5)
				{
					state = 5;
				}
				else
				{
					state = 0;
				}
				break;
			}
			case 5:
			{
				if(U1RXREG == 0x5A)
				{
					state = 6;
				}
				else
				{
					state = 0;
				}
				break;
			}
			case 6:
			{
				data_set = U1RXREG;
				
				state = 0;

				break;
			}
		}
	}
}
