#!/bin/sh
export GDFONTPATH="/usr/share/fonts/TTF/"
gnuplot << EOF
#set term x11
set term png font "arialbd.ttf" 18 size 950,600
set output "GenConst-48mm.png"
set title "Generator Constant"
set key noautotitles
unset mouse
set bmargin 4
set grid xtics ytics
set xlabel "Shaft Speed - rev/min"
set ylabel "Output Voltage - V"
f(x) = m*x + c
fit f(x) "GenConst-48mmACT.csv" using 3:4 via m,c
set label 1 sprintf("m = %7.5f",m) at 1020,8.4 font "arialbd,18"
set label 2 sprintf("c = %7.5f",c) at 1020,6.4 font "arialbd,18"
set rmargin 4
plot	\
	"GenConst-48mmACT.csv" \
	using 3:4 with linespoints lt 3 ,\
	f(x) lt 4 lw 2
EOF
