#!/bin/sh
export GDFONTPATH="/usr/share/fonts/TTF/"
gnuplot << EOF
#set term x11
set term png font "arialbd.ttf" 18 size 950,600
set output "Microstepping Mode vs Speed - 17PM-J034.png"
set title "Microstepping Mode vs Speed"
set key noautotitles
unset mouse
set bmargin 4
set grid xtics ytics
set logscale x
set xlabel "Shaft Speed - rev/min"
set xrange [50:2000]
set ylabel "Torque - mNm"
set yrange [0:160]
set rmargin 4
set label 10 "Caret = full-step" at 110,25 font "arialbd,18"
set label 1 "^" at 56,121 center font "arialbd,18" offset 0,-0.8
set label 2 "^" at 100,102 center font "arialbd,18" offset 0,-0.8
set label 3 "^" at 239,75 center font "arialbd,18" offset 0,-0.8
set label 4 "^" at 384,91 center font "arialbd,18" offset 0,-0.8
set label 5 "^" at 539,84 center font "arialbd,18" offset 0,-0.8
set label 6 "^" at 608,79 center font "arialbd,18" offset 0,-0.8
set label 7 "^" at 793,68 center font "arialbd,18" offset 0,-0.8
set label 8 "^" at 1193,61 center font "arialbd,18" offset 0,-0.8
plot	\
	"Data - 0 ohm - 1 A - J034 motor.csv" \
	using 4:9 with points lt 3 pt 7 ,\
	"Data - 1 ohm - 1 A - J034 motor.csv" \
	using 4:9 with points lt 4 pt 7 ,\
	"Data - 4 ohm - 1 A - J034 motor.csv" \
	using 4:9 with points lt 6 pt 7 , \
	"Data - 8 ohm - 1 A - J034 motor.csv" \
	using 4:9 with points lt 8 pt 7 , \
	"Data - 12 ohm - 1 A - J034 motor.csv" \
	using 4:9 with points lt 2 pt 7 , \
	"Data - 16 ohm - 1 A - J034 motor.csv" \
	using 4:9 with points lt 1 pt 7 , \
	"Data - 27 ohm - 1 A - J034 motor.csv" \
	using 4:9 with points lt 9 pt 7 , \
	"Data - 50 ohm - 1 A - J034 motor.csv" \
	using 4:9 with points lt 10 pt 7
EOF
